// using  piezo buzzer: + pin in G26 and GND pin in GND
// This does NOT use the Arduino Tone or New Tone libraries
// based on https://techtutorialsx.com/2017/07/01/esp32-arduino-controlling-a-buzzer-with-pwm/
// demo for workshop
// http://tinkerfarm.net/workshops/m5stickc-workshop-2019/

// include stick library
#include <M5StickC.h>


// create some variables we will use
  // initial frequency
  int freq = 2000;
  // channel for the pin
  int channel = 0;
  // 8 bit resolution
  int resolution = 8;
  
void setup() {

  // serial monitor
  Serial.begin(115200);

  // assign GPIO pin using LED library to get PWM
  ledcSetup(channel, freq, resolution);
  ledcAttachPin(26, channel);

  // TFT LCD display set up
  M5.begin();
  M5.Lcd.setRotation(0);
  M5.Lcd.fillScreen(TFT_BLACK);
  M5.Lcd.setCursor(0, 0, 2);
  M5.Lcd.setTextSize(2);
  
}
  
void loop() {
  
  // send a tone
  ledcWriteTone(channel, 2000);

  // vary the PWM cycle time, this gives us volume control
  for (int dutyCycle = 0; dutyCycle <= 255; dutyCycle=dutyCycle+10){
  
    // echo the output
    Serial.println(dutyCycle);
    M5.Lcd.println(dutyCycle);
    M5.Lcd.setCursor(0, 0, 2);
  
    ledcWrite(channel, dutyCycle);
    delay(1000);
  }

  // reset to low frequency
  ledcWrite(channel, 125);
  
  // vary the frequency, this gives us tone control (notes)
  for (int freq = 255; freq < 10000; freq = freq + 250){
  
     Serial.println(freq);
     M5.Lcd.setCursor(0, 0, 2);
     M5.Lcd.println(freq);
  
     ledcWriteTone(channel, freq);
     delay(1000);
  }
  
  // clear the screen
  M5.Lcd.fillScreen(TFT_BLACK);  

}
