// connecting to stick over BLE
// for workshop
// http://tinkerfarm.net/workshops/m5stickc-workshop-2019/
/*
    Adapted from
    Based on Neil Kolban example for IDF: https://github.com/nkolban/esp32-snippets/blob/master/cpp_utils/tests/BLE%20Tests/SampleServer.cpp
    Ported to Arduino ESP32 by Evandro Copercini
    updates by chegewara
*/

// include BLE libraries
#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEServer.h>

// insert a name for your device, also needed in BLEdevice::init
  String deviceName = "XXXX";



// identify a service and characterstic
// See the following for generating UUIDs:
// https://www.uuidgenerator.net/
#define SERVICE_UUID        "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define CHARACTERISTIC_UUID "36149f2c-9a7e-4f3c-8829-4b2db9df618b"

void setup() {
  Serial.begin(115200);
  Serial.println("Starting BLE");

  // Initialize BLE with your name
  BLEDevice::init("XXXX");
  
  BLEServer *pServer = BLEDevice::createServer();
  BLEService *pService = pServer->createService(SERVICE_UUID);
  BLECharacteristic *pCharacteristic = pService->createCharacteristic(
                                         CHARACTERISTIC_UUID,
                                         BLECharacteristic::PROPERTY_READ |
                                         BLECharacteristic::PROPERTY_WRITE
                                       );

  
  // insert a name for your service
  pCharacteristic->setValue("Test characteristic");
  pService->start();
  
  // BLEAdvertising *pAdvertising = pServer->getAdvertising();  // this still is working for backward compatibility
  BLEAdvertising *pAdvertising = BLEDevice::getAdvertising();
  pAdvertising->addServiceUUID(SERVICE_UUID);
  pAdvertising->setScanResponse(true);
  pAdvertising->setMinPreferred(0x06);  // functions that help with iPhone connections issue
  pAdvertising->setMinPreferred(0x12);
  BLEDevice::startAdvertising();
  Serial.print("Scan for device: ");
  Serial.println(deviceName);
  Serial.println("Characteristic defined. Now you can read it on your BLE device.");
}

void loop() {
  // put your main code here, to run repeatedly:
  delay(2000);
}
